#! /bin/sh
#------------------------------------------------------------------------------
# /tmp/preinstall.sh - eisxen preinstallation script
#
# Creation   : 2009-06-11  schlotze
# Last update: $Id: preinstall.sh 20090 2009-06-15 16:05:22Z schlotze $
#
# Copyright (c) 2009 the eisfair team, c/o Frank Meyer, <frank(at)eisfair(dot)org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------

## user for debug:
#exec 2> /tmp/eisxen-preinstall$$.log
#set -x

# include eislib
. /var/install/include/eislib

# set packages name
packages_name="eisxen"

#
/usr/local/bin/dtou /var/install/packages/eisxen

#------------------------------------------------------------------------------
# check for RC 5. This update should only be installable to the eisxen RC 5 
#------------------------------------------------------------------------------
installedEisxenVersion=`/var/install/bin/check-version eisxen 1.0.0`
installedRC=`grep -i "RC 5" /etc/issue | awk '{print $4}'`
if [ "$installedEisxenVersion" = "not-installed" ]
then
    mecho -error "This update is only installable on eisxen RC 5!"
    mecho -warn "exiting..."
    exit 1
fi
if [ "$installedRC" != "5" ]
then
    mecho -error "This update is only installable on eisxen RC 5!"
    mecho -warn "exiting..."
    exit 1
fi

exit 0
#------------------------------------------------------------------------------
# end
#------------------------------------------------------------------------------

