#!/bin/sh
#---------------------------------------------------------------------------
# /var/install/bin/xen-pre-setup.sh
#
# Creation:     07.10.2007 rg
# Last Update:  $Id: xen-pre-setup.sh 16127 2008-08-10 21:15:56Z schlotze $
#
# Copyright (c) 2007, 2008 the eisfair team, team(at)eisfair(dot)org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#---------------------------------------------------------------------------
. /var/install/include/xenlib

#exec 2> /tmp/xen-pre-setup-trace$$.log
#set -x

search_4_configfiles

# clean old symlinks and menu-files
rm -f /etc/check.d/$domUConfigPrefix$delimiter*
rm -f $defaultDomUConfigfile$delimiter*
rm -f /var/install/config.d/$domUConfigPrefix$delimiter*.sh
rm -f /var/install/help/$domUConfigPrefix$delimiter*
rm -f /var/install/menu/setup.$domUConfigPrefix$delimiter*.menu
rm -f /etc/init.d/$domUConfigPrefix$delimiter*

# and create everything new

create_links_and_menus() {
    ln -s -T /etc/check.d/$domUConfigPrefix /etc/check.d/$domUConfigPrefix$delimiter$name
    ln -s -T /etc/check.d/xen.exp /etc/check.d/$domUConfigPrefix$delimiter$name.exp
    ln -s -T $defaultDomUConfigfile $defaultDomUConfigfile$delimiter$name
    ln -s -T /var/install/config.d/xmdomu.sh /var/install/config.d/$domUConfigPrefix$delimiter$name.sh
    ln -s -T /var/install/help/$domUConfigPrefix /var/install/help/$domUConfigPrefix$delimiter$name
    ln -s -T /etc/init.d/$domUConfigPrefix /etc/init.d/$domUConfigPrefix$delimiter$name
    /var/install/bin/add-menu setup.xen.domu.menu setup.$domUConfigPrefix$delimiter$name.menu "Domain $name"
    cat > /var/install/menu/setup.$domUConfigPrefix$delimiter$name.menu << EOF
<!-- /var/install/menu/setup.$domUConfigPrefix$delimiter$name.menu -->
<!-- Do not edit this file. This file is not persistent -->
<!-- Created from $Id: xen-pre-setup.sh 16127 2008-08-10 21:15:56Z schlotze $ -->
<title>Administration of domain $name</title>
<package>$domUConfigPrefix$delimiter$name</package>
<edit>Edit Configuration</edit>
<script file="xen-maintain-domain manage_domain $name">Manage Domain $name</script>
<script file="xen-maintain-domain check_modules $name">Update Kernel Modules</script>
<script file="xen-maintain-domain delete_domain $name">Delete Domain $name</script>
EOF
}

cat > /var/install/menu/setup.xen.domu.menu << EOF
<!-- /var/install/menu/setup.xen.domu.menu -->
<!-- Do not edit this file. This file is not persistent -->
<!-- Created from $Id: xen-pre-setup.sh 16127 2008-08-10 21:15:56Z schlotze $ -->
<title>domU Administration</title>
<package>xen</package>
<script file="xen-domain-config">Manage domains</script>
<script file="xen-create-domain">Create new domain from template</script>
<script file="xen-import-domain">Add domain to config</script>
EOF

for dom in $domUConfigfile$delimiter*
do
    name=`echo $dom | sed 's#^'$domUConfigfile$delimiter'##'`
    if [ "$name" != "*" ]
    then
        create_links_and_menus
    fi
done
