#!/bin/sh
#-------------------------------------------------------------------------------
# /var/install/config.d/xen.sh - configuration generator script for xen
#
# Creation:     21.05.05 fw
# Last Update:  $Id: xen.sh 16042 2008-08-05 20:41:06Z rg $
#
# Copyright (c) 2007 the eisfair team, team(at)eisfair(dot)org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#-------------------------------------------------------------------------------
. /var/install/include/xenlib

#exec 2> /tmp/xen.sh-trace$$.log
#set -x

. ${configfile}

if xend status >/dev/null 2>&1
then
    xendRunning="yes"
else
    xendRunning="no"
fi

if [ "$START_XEN" = "yes" ]
then
    cd /etc/rc2.d
    ln -sf ../init.d/xen S85xen
    cd /etc/rc0.d
    ln -sf ../init.d/xen K15xen
    cd /etc/rc6.d
    ln -sf ../init.d/xen K15xen
else
    rm -f /etc/rc2.d/S??xen
fi

#
# xen configuration
#
cat << EOF >$xendConfigfile
(xend-relocation-server yes)
(xend-relocation-hosts-allow '^localhost$')
(network-script /bin/true)
(vif-script vif-bridge)
(dom0-min-mem $XEN_DOM0_MIN_MEM)
(dom0-cpus 0)
(vnc-listen '0.0.0.0')
EOF

if [ "$XEN_API" = "yes" ]
then
    # set listen address
    if [ "$XEN_API_LISTEN_ADDR" = "0" ]
    then
        XEN_API_LISTEN_ADDR=''
    else
        . /etc/config.d/base
        if [ $XEN_API_LISTEN_ADDR -le $IP_NET_N ]
        then
            eval XEN_API_LISTEN_ADDR='${IP_NET_'$XEN_API_LISTEN_ADDR'_IPADDR}:'
        else
            if [ $IP_NET_N -gt 1 ]
            then
                mecho -warn "Invalid XEN_API_LISTEN_ADDR. Interface $XEN_API_LISTEN_ADDR does not exist."
                mecho -warn "Xen-API will listen on all interfaces!"
            fi
            XEN_API_LISTEN_ADDR=''
        fi
    fi

    APIstring="${XEN_API_LISTEN_ADDR}${XEN_API_PORT} ${XEN_API_AUTHTYPE}"

    # set allowed hosts            Funktioniert nicht:
    if [ $XEN_API_HOST_N -gt 0 ]
    then
        host=$XEN_API_HOST_1
        host=`echo $host | sed -e 's#\.#\\\\\\\.#g'`
        APIhost="^${host}$"
        idx=2
        while [ $idx -le $XEN_API_HOST_N ]
        do
            eval host='$XEN_API_HOST_'${idx}
            host=`echo $host | sed -e 's#\.#\\\\\\\.#g'`
            APIhost="${APIhost} ^${host}$"
            idx=`expr $idx + 1`
        done
        APIstring="${APIstring} '${APIhost}'"
    fi

    if [ "$XEN_API_SOCKET" = "yes" ]
    then
        echo "(xen-api-server ((${APIstring})(unix none)))" >>$xendConfigfile
    else
        echo "(xen-api-server ((${APIstring})))" >>$xendConfigfile
    fi
else
    if [ "$XEN_API_SOCKET" = "yes" ]
    then
        echo "(xen-api-server ((unix none)))" >>$xendConfigfile
    fi
fi

# XXX: api handling
if [ "$XEN_API_XML" = "yes" ]
then
    [ -f ${xmConfigfile}.disabled ] && rm ${xmConfigfile}.disabled
    cat << EOF >${xmConfigfile}
<xm>
  <server type='Xen-API'
           uri='httpu:///var/run/xend/xen-api.sock' />
</xm>
EOF
else
    [ -f ${xmConfigfile} ] && mv ${xmConfigfile} ${xmConfigfile}.disabled
fi
